﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Public MyTheme As ABMTheme
	Private ABM As ABMaterial 'ignore
	Public NeedsAuthorization As Boolean = False
	Public AppVersion As String = DateTime.now ' NEW 2.01 this helps to get the latest js/css files when the app is started/restarted
	Public AppPublishedStartURL As String = ""
	Public AppName As String = ""
	
	Public CachedPages As Map
	Public CacheScavengePeriodSeconds As Int = 15*60 ' 15 minutes
	Public SessionMaxInactiveIntervalSeconds As Int = 30*60 ' 30 minutes '1*60*24 ' one hour ' -1 = immortal but beware! This also means your cache is NEVER emptied!
	Public Port As Int = 51042
	Public PortSSL As Int = 0
	
	Private myApp As ABMApplication
		
	Public srvr As Server
	
	Public UploadFolder As String = "uploads"
	Public UploadMaxSize As Long = 1024*1024
	Private mDonatorKey As String
	Private LogsOutput As OutputStream
	Private mStartPage As String
End Sub

'Initializes the server.  Should be done in Main.
'if a INI file is used, it should contain the following parameters
'Port=
'PortSSL=
'CacheScavengePeriodSeconds=
'SessionMaxInactiveIntervalSeconds=
Public Sub Initialize(INIFileFullPath As String, DonatorKey As String, ApplicationName As String)
	AppName = ApplicationName
	mDonatorKey = DonatorKey
	myApp.Initialize
	srvr.Initialize("srvr")
	If INIFileFullPath <> "" Then
		If File.Exists("", INIFileFullPath) Then
			Dim INIInfo As List = File.ReadList("", INIFileFullPath)
			For i = 0 To INIInfo.Size - 1
				Dim line As String = INIInfo.Get(i)
				If line.StartsWith("Port=") Then
					Port = line.SubString("Port=".Length)
				End If
				If line.StartsWith("PortSSL=") Then
					PortSSL = line.SubString("PortSSL=".Length)
				End If
				If line.StartsWith("CacheScavengePeriodSeconds=") Then
					CacheScavengePeriodSeconds = line.SubString("CacheScavengePeriodSeconds=".Length)
				End If
				If line.StartsWith("SessionMaxInactiveIntervalSeconds=") Then
					SessionMaxInactiveIntervalSeconds = line.SubString("SessionMaxInactiveIntervalSeconds=".Length)
				End If
			Next
		End If
	End If
End Sub

public Sub getDonatorKey() As String
	Return mDonatorKey
End Sub

public Sub setStartPage(startPageName As String)
	mStartPage = startPageName
	myApp.InitialPage = startPageName
End Sub

public Sub getStartPage() As String
	Return mStartPage
End Sub

' redirects the logs
public Sub RedirectOutput (Dir As String, FileName As String)
#if RELEASE
	If LogsOutput.IsInitialized Then LogsOutput.Close
	LogsOutput = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
	Log("Redirecting logs to: " & FileName)
	Dim ps As JavaObject
	ps.InitializeNewInstance("java.io.PrintStream", Array(LogsOutput, True, "utf8"))
	Dim jo As JavaObject
	jo.InitializeStatic("java.lang.System")
	jo.RunMethod("setOut", Array(ps))
	jo.RunMethod("setErr", Array(ps))
#end if
End Sub

' Parses the event coming from the BROWSER arriving in Page_ParseEvent. It will redirect the calls to the proper B4J methods.
' 
' self - the class that has the method, typically Me
' Page - The ABPage object
' ABMPageID - the current pageID.  If the event is beforeunload (internal), then it will be removed from CachedPages
' Params - the Params parameter you received in BANano_ParseEvent
'
' Typical usage:
' public Sub Page_ParseEvent(params As Map)
'	  Main.ABMServer.ParseEvent(Me, Page, ABMPageID, params)
' End Sub

Sub Page_ParseEvent(Self As Object, Page As ABMPage, ABMPageID As String, Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	
	Dim group() As String
    If eventName == "plantab-calendar_dayclicked" Then
        group = Regex.Split("-", eventName) '' split eventName at dash "-"
        eventName = group(1).Trim ''' get the second line after splitting which should be calendar1_dayclicked
    End If
	
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(Main.Server.CachedPages, ABMPageID)
		Return
	End If
	Dim caller As Object = Page.GetEventHandler(Self, eventName)
	If caller = Self Then
		If SubExists(Self, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			
			If eventName = "page_dropped" Then
				Page.ProcessDroppedEvent(Params)
			End If
			
			Select Case Params.Size
				Case 0
					CallSub(Self, eventName)
				Case 1
					CallSub2(Self, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Self, eventName, PassedTables)
					Else
						CallSub3(Self, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Self, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub


Public Sub NavigateToPage(ws As WebSocket, PageId As String, TargetUrl As String) 'ignore
	Dim testTargetUrl As String = TargetUrl
	If Not(testTargetUrl.EndsWith(".htm") Or testTargetUrl.EndsWith(".html") Or testTargetUrl.EndsWith("/")) Then
		TargetUrl = TargetUrl & "/"
	End If
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		' it doesn't keep navigation history in the browser (the back button exists the application)
		ws.Eval("window.location.replace(arguments[0])", Array As Object(TargetUrl))
		' if you need browser history just comment the lines above and uncomment the lines below
		' it keeps the navigation history in the browser
		''ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
		ws.Flush
		''ws.Close ' ALSO NEW 4.00
		' note that this error can be ignored anyway
		' if you are bothered by the warning error you get with this close, you can try to replace it with this:
				
		Sleep(50)
		If ws.Open Then
			Log("closing the websocket, in case the eval does not do it...")
			ws.Close ' ALSO NEW 4.00
		End If
	End If
End Sub

Public Sub NavigateToPageNewTab(ws As WebSocket, PageId As String, TargetUrl As String, OpenInNewTab As Boolean) 'ignore
	Dim testTargetUrl As String = TargetUrl
	If Not(testTargetUrl.EndsWith(".htm") Or testTargetUrl.EndsWith(".html") Or testTargetUrl.EndsWith("/")) Then
		TargetUrl = TargetUrl & "/"
	End If
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		If OpenInNewTab Then
			Dim s As String
			' check if a mobile phone only
'			s = $"var check = false;
			'  			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
			'  			if (check) {
			'  				window.location = arguments[0];
			'  			} else {
			'  				window.open(arguments[0],'_blank');
			'  			}"$
			
			' check if a mobile phone or a tablet
			s = $"var check = false;
  			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
   			if (check) {
  				window.location = arguments[0];
  			} else {
				window.open(arguments[0],'_blank');  				
  			}"$			
			ws.Eval(s, Array As Object(TargetUrl))
		Else
			ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
		End If
		ws.Flush
		ws.Close ' ALSO NEW 4.00
	End If
End Sub

Sub AddPage(page As ABMPage)
	myApp.AddPage(page)
End Sub

Sub StartServer()
	myApp.StartServer(srvr, "srvr", Port)
End Sub

Sub StartServerHTTP2(KeyStoreFileName As String, KeyStorePassword As String, KeyManagerPassword As String)
	myApp.StartServerHTTP2(srvr, "srvr", Port, PortSSL, KeyStoreFileName, KeyStorePassword, KeyManagerPassword)
End Sub

Sub GetSSLConfiguration() as SslConfiguration
	Return myApp.ssl
end Sub

Sub Connected(Caller As Object, ws As WebSocket, page As ABMPage, pageID As String) As String
	Dim session As HttpSession = ABM.GetSession(ws, Main.Server.SessionMaxInactiveIntervalSeconds)
	If session.IsNew Then
		session.Invalidate
		Main.Server.NavigateToPage(ws, "", "./")
		Return pageID
	End If
		
	If Main.Server.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			Main.Server.NavigateToPage(ws, pageID, "../")
			Return pageID
		End If
	End If
	ABM.UpdateFromCache(Caller, Main.Server.CachedPages, pageID, ws)
	If page.ComesFromPageCache Then
		' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		Log("Comes from cache")
		page.Refresh
		page.FinishedLoading
	Else
		If page.WebsocketReconnected Then
			Log("Websocket reconnected")
			' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have any on the server. So we need to reload the page.
			' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has content, reconnected but we have no content in cache
			Main.Server.NavigateToPage (ws, pageID, "./" & page.PageHTMLName)
		Else
			' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
			Log("Websocket first connection")
			page.Prepare
			CallSub(Caller, "ConnectPage")
		End If
	End If
			
	ws.Session.SetAttribute("abmcallback", Me)
	ws.Session.SetAttribute("abmdownloadfolder", Main.Server.UploadFolder)
	ws.Session.SetAttribute("abmmaxsize", Main.Server.UploadMaxSize)
	Return pageID
End Sub

Sub Disconnected(ws As WebSocket) 
	Try
		ws.Session.RemoveAttribute("abmcallback")
		ws.Session.RemoveAttribute("abmdownloadfolder")
		ws.Session.RemoveAttribute("abmmaxsize")
	Catch
		Log(LastException.Message)
	End Try
End Sub
